Index: /XIOS/dev/branch_yushan_merged/extern/src_ep_dev/ep_create.cpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/extern/src_ep_dev/ep_create.cpp	(revision 1134)
+++ /XIOS/dev/branch_yushan_merged/extern/src_ep_dev/ep_create.cpp	(revision 1134)
@@ -0,0 +1,282 @@
+/*!
+   \file ep_create.cpp
+   \since 2 may 2016
+
+   \brief Definitions of MPI endpoint function: MPI_Comm_create_endpoints
+ */
+
+#include "ep_lib.hpp"
+#include <mpi.h>
+#include "ep_declaration.hpp"
+
+using namespace std;
+
+
+
+namespace ep_lib {
+
+  /*!
+    Dynamic creation of endpoints for each MPI process.
+    The output of this function is an array of communicator handles of length num_ep, where each handle
+    corresponds to a nez local randk in the output communicator.
+    Once created, endpoints behave as MPI processes.
+    \param [in] mpi_comm Parent MPI communicator.
+    \param [in] num_ep Number of endpoints per process.
+    \param [out] info Information of the EP creation.
+    \param [out] out_comm_hdls Handles of EP communicators.
+  */
+  #ifdef _intelmpi
+  int MPI_Comm_create_endpoints(int base_comm_ptr, int num_ep, MPI_Info info, MPI_Comm *& out_comm_hdls)
+  {
+    int base_rank;
+    int base_size;
+
+    ::MPI_Comm mpi_base_comm = static_cast< ::MPI_Comm> (base_comm_ptr);
+
+    ::MPI_Comm_size(mpi_base_comm, &base_size);  // ep_lib::mpi_comm_size
+    ::MPI_Comm_rank(mpi_base_comm, &base_rank);  // ep_lib::mpi_comm_rank
+									  // parent_comm can also be endpoints communicators
+
+    std::vector<int> recv_num_ep(base_size);
+
+    out_comm_hdls = new MPI_Comm[num_ep];
+
+    for (int idx = 0; idx < num_ep; ++idx)
+    {
+      out_comm_hdls[idx].is_ep = true;
+      out_comm_hdls[idx].is_intercomm = false;
+      out_comm_hdls[idx].ep_comm_ptr = new ep_communicator;
+      out_comm_hdls[idx].mpi_comm = base_comm_ptr;
+      out_comm_hdls[idx].ep_comm_ptr->comm_list = out_comm_hdls;
+      out_comm_hdls[idx].ep_comm_ptr->comm_label = 0;
+    }
+
+    ::MPI_Allgather(&num_ep, 1, MPI_INT_STD, &recv_num_ep[0], 1, MPI_INT_STD, mpi_base_comm);
+
+
+    int sum = 0;  // representing total ep number of process with smaller rank
+    for (int i = 0; i < base_rank; ++i) {sum += recv_num_ep[i]; }
+
+    int ep_size = std::accumulate(recv_num_ep.begin(), recv_num_ep.end(), 0);
+
+    out_comm_hdls[0].ep_barrier = new OMPbarrier(num_ep);
+
+    out_comm_hdls[0].my_buffer = new BUFFER;
+    out_comm_hdls[0].my_buffer->buf_double = new double[BUFFER_SIZE];
+    out_comm_hdls[0].my_buffer->buf_float  = new float[BUFFER_SIZE];
+    out_comm_hdls[0].my_buffer->buf_int    = new int[BUFFER_SIZE];
+    out_comm_hdls[0].my_buffer->buf_long   = new long[BUFFER_SIZE];
+    out_comm_hdls[0].my_buffer->buf_ulong  = new unsigned long[BUFFER_SIZE];
+    out_comm_hdls[0].my_buffer->buf_char   = new char[BUFFER_SIZE];
+
+    out_comm_hdls[0].rank_map = new RANK_MAP;
+    out_comm_hdls[0].rank_map->resize(ep_size);
+
+
+    for (int i = 1; i < num_ep; i++)
+    {
+      out_comm_hdls[i].ep_barrier = out_comm_hdls[0].ep_barrier;
+      out_comm_hdls[i].my_buffer  = out_comm_hdls[0].my_buffer;
+      out_comm_hdls[i].rank_map   = out_comm_hdls[0].rank_map;
+    }
+
+
+    for (int i = 0; i < num_ep; i++)
+    {
+      out_comm_hdls[i].ep_comm_ptr->size_rank_info[0] = std::make_pair(sum+i, ep_size);
+      out_comm_hdls[i].ep_comm_ptr->size_rank_info[1] = std::make_pair(i, num_ep);
+      out_comm_hdls[i].ep_comm_ptr->size_rank_info[2] = std::make_pair(base_rank, base_size);
+
+      out_comm_hdls[i].ep_comm_ptr->message_queue = new Message_list;
+    }
+
+
+    int ind = 0;
+
+    for(int i=0; i<base_size; i++)
+    {
+      for(int j=0; j<recv_num_ep[i]; j++)
+      {
+        out_comm_hdls[0].rank_map->at(ind) = make_pair(j, i);
+        ind++;
+      }
+    }
+
+    // printf("ep_lib::MPI_Comm_create_endpoints()       OK from int\n");
+
+    return 0;
+
+  } //MPI_Comm_create_endpoints
+
+  #elif _openmpi
+  int MPI_Comm_create_endpoints(void* base_comm_ptr, int num_ep, MPI_Info info, MPI_Comm *& out_comm_hdls)
+  {
+
+    int base_rank;
+    int base_size;
+
+    ::MPI_Comm mpi_base_comm = static_cast< ::MPI_Comm> (base_comm_ptr);
+
+    ::MPI_Comm_size(mpi_base_comm, &base_size);  // ep_lib::mpi_comm_size
+    ::MPI_Comm_rank(mpi_base_comm, &base_rank);  // ep_lib::mpi_comm_rank
+                                                 // parent_comm can also be endpoints communicators ?
+    std::vector<int> recv_num_ep(base_size);
+
+    out_comm_hdls = new MPI_Comm[num_ep];
+
+    for (int idx = 0; idx < num_ep; ++idx)
+    {
+      out_comm_hdls[idx].is_ep = true;
+      out_comm_hdls[idx].is_intercomm = false;
+      out_comm_hdls[idx].ep_comm_ptr = new ep_communicator;
+      out_comm_hdls[idx].mpi_comm = base_comm_ptr;
+      out_comm_hdls[idx].ep_comm_ptr->comm_list = out_comm_hdls;
+      out_comm_hdls[idx].ep_comm_ptr->comm_label = 0;
+    }
+
+    ::MPI_Allgather(&num_ep, 1, MPI_INT_STD, &recv_num_ep[0], 1, MPI_INT_STD, mpi_base_comm);
+
+    int sum = 0;  // representing total ep number of process with smaller rank
+    for (int i = 0; i < base_rank; ++i) {sum += recv_num_ep[i]; }
+
+    int ep_size = std::accumulate(recv_num_ep.begin(), recv_num_ep.end(), 0);
+
+    out_comm_hdls[0].ep_barrier = new OMPbarrier(num_ep);
+
+    out_comm_hdls[0].my_buffer = new BUFFER;
+    out_comm_hdls[0].my_buffer->buf_double = new double[BUFFER_SIZE];
+    out_comm_hdls[0].my_buffer->buf_float  = new float[BUFFER_SIZE];
+    out_comm_hdls[0].my_buffer->buf_int    = new int[BUFFER_SIZE];
+    out_comm_hdls[0].my_buffer->buf_long   = new long[BUFFER_SIZE];
+    out_comm_hdls[0].my_buffer->buf_ulong  = new unsigned long[BUFFER_SIZE];
+    out_comm_hdls[0].my_buffer->buf_char   = new char[BUFFER_SIZE];
+
+    out_comm_hdls[0].rank_map = new RANK_MAP;
+    out_comm_hdls[0].rank_map->resize(ep_size);
+
+
+    for (int i = 1; i < num_ep; i++)
+    {
+      out_comm_hdls[i].ep_barrier = out_comm_hdls[0].ep_barrier;
+      out_comm_hdls[i].my_buffer  = out_comm_hdls[0].my_buffer;
+      out_comm_hdls[i].rank_map   = out_comm_hdls[0].rank_map;
+    }
+
+
+    for (int i = 0; i < num_ep; i++)
+    {
+      out_comm_hdls[i].ep_comm_ptr->size_rank_info[0] = std::make_pair(sum+i, ep_size);
+      out_comm_hdls[i].ep_comm_ptr->size_rank_info[1] = std::make_pair(i, num_ep);
+      out_comm_hdls[i].ep_comm_ptr->size_rank_info[2] = std::make_pair(base_rank, base_size);
+
+      out_comm_hdls[i].ep_comm_ptr->message_queue = new Message_list;
+    }
+
+
+    int ind = 0;
+
+    for(int i=0; i<base_size; i++)
+    {
+      for(int j=0; j<recv_num_ep[i]; j++)
+      {
+        out_comm_hdls[0].rank_map->at(ind) = make_pair(j, i);
+        ind++;
+      }
+    }
+
+    //printf("ep_lib::MPI_Comm_create_endpoints()       OK from void*\n");
+
+    return 0;
+
+  } //MPI_Comm_create_endpoints
+
+  #endif
+  
+  
+  int MPI_Comm_create_endpoints(MPI_Comm base_comm, int num_ep, MPI_Info info, MPI_Comm *& out_comm_hdls)
+  {
+
+    int base_rank;
+    int base_size;
+    
+    assert(!base_comm.is_ep);
+
+    ::MPI_Comm mpi_base_comm = static_cast< ::MPI_Comm> (base_comm.mpi_comm);
+
+    ::MPI_Comm_size(mpi_base_comm, &base_size);  // ep_lib::mpi_comm_size
+    ::MPI_Comm_rank(mpi_base_comm, &base_rank);  // ep_lib::mpi_comm_rank
+                    // parent_comm can also be endpoints communicators
+
+    std::vector<int> recv_num_ep(base_size);
+
+    out_comm_hdls = new MPI_Comm[num_ep];
+
+    for (int idx = 0; idx < num_ep; ++idx)
+    {
+      out_comm_hdls[idx].is_ep = true;
+      out_comm_hdls[idx].is_intercomm = false;
+      out_comm_hdls[idx].ep_comm_ptr = new ep_communicator;
+      out_comm_hdls[idx].mpi_comm = base_comm.mpi_comm;
+      out_comm_hdls[idx].ep_comm_ptr->comm_list = out_comm_hdls;
+      out_comm_hdls[idx].ep_comm_ptr->comm_label = 0;
+    }
+
+    ::MPI_Allgather(&num_ep, 1, MPI_INT_STD, &recv_num_ep[0], 1, MPI_INT_STD, mpi_base_comm);
+
+
+    int sum = 0;  // representing total ep number of process with smaller rank
+    for (int i = 0; i < base_rank; ++i) {sum += recv_num_ep[i]; }
+
+    int ep_size = std::accumulate(recv_num_ep.begin(), recv_num_ep.end(), 0);
+
+    out_comm_hdls[0].ep_barrier = new OMPbarrier(num_ep);
+
+    out_comm_hdls[0].my_buffer = new BUFFER;
+    out_comm_hdls[0].my_buffer->buf_double = new double[BUFFER_SIZE];
+    out_comm_hdls[0].my_buffer->buf_float  = new float[BUFFER_SIZE];
+    out_comm_hdls[0].my_buffer->buf_int    = new int[BUFFER_SIZE];
+    out_comm_hdls[0].my_buffer->buf_long   = new long[BUFFER_SIZE];
+    out_comm_hdls[0].my_buffer->buf_ulong  = new unsigned long[BUFFER_SIZE];
+    out_comm_hdls[0].my_buffer->buf_char   = new char[BUFFER_SIZE];
+
+    out_comm_hdls[0].rank_map = new RANK_MAP;
+    out_comm_hdls[0].rank_map->resize(ep_size);
+
+
+    for (int i = 1; i < num_ep; i++)
+    {
+      out_comm_hdls[i].ep_barrier = out_comm_hdls[0].ep_barrier;
+      out_comm_hdls[i].my_buffer  = out_comm_hdls[0].my_buffer;
+      out_comm_hdls[i].rank_map   = out_comm_hdls[0].rank_map;
+    }
+
+
+    for (int i = 0; i < num_ep; i++)
+    {
+      out_comm_hdls[i].ep_comm_ptr->size_rank_info[0] = std::make_pair(sum+i, ep_size);
+      out_comm_hdls[i].ep_comm_ptr->size_rank_info[1] = std::make_pair(i, num_ep);
+      out_comm_hdls[i].ep_comm_ptr->size_rank_info[2] = std::make_pair(base_rank, base_size);
+
+      out_comm_hdls[i].ep_comm_ptr->message_queue = new Message_list;
+    }
+
+
+    int ind = 0;
+
+    for(int i=0; i<base_size; i++)
+    {
+      for(int j=0; j<recv_num_ep[i]; j++)
+      {
+        out_comm_hdls[0].rank_map->at(ind) = make_pair(j, i);
+        ind++;
+      }
+    }
+
+    // printf("ep_lib::MPI_Comm_create_endpoints()       OK from MPI_Comm\n");
+
+    return 0;
+
+  } //MPI_Comm_create_endpoints
+
+
+} //namespace ep_lib
Index: /XIOS/dev/branch_yushan_merged/extern/src_ep_dev/ep_declaration.cpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/extern/src_ep_dev/ep_declaration.cpp	(revision 1134)
+++ /XIOS/dev/branch_yushan_merged/extern/src_ep_dev/ep_declaration.cpp	(revision 1134)
@@ -0,0 +1,69 @@
+
+
+#include "ep_lib.hpp"
+
+#include <mpi.h>
+
+#undef MPI_INT
+#undef MPI_FLOAT
+#undef MPI_DOUBLE
+#undef MPI_CHAR
+#undef MPI_LONG
+#undef MPI_UNSIGNED_LONG
+#undef MPI_UNSIGNED_CHAR
+
+#undef MPI_SUM
+#undef MPI_MAX
+#undef MPI_MIN
+
+#undef MPI_COMM_WORLD
+#undef MPI_COMM_NULL
+
+#undef MPI_STATUS_IGNORE
+#undef MPI_REQUEST_NULL
+#undef MPI_INFO_NULL
+
+
+
+// _STD defined in ep_type.cpp
+
+extern ::MPI_Datatype MPI_INT_STD;
+extern ::MPI_Datatype MPI_FLOAT_STD;
+extern ::MPI_Datatype MPI_DOUBLE_STD;
+extern ::MPI_Datatype MPI_LONG_STD;
+extern ::MPI_Datatype MPI_CHAR_STD;
+extern ::MPI_Datatype MPI_UNSIGNED_LONG_STD;
+extern ::MPI_Datatype MPI_UNSIGNED_CHAR_STD;
+
+extern ::MPI_Op MPI_SUM_STD;
+extern ::MPI_Op MPI_MAX_STD;
+extern ::MPI_Op MPI_MIN_STD;
+
+extern ::MPI_Comm MPI_COMM_WORLD_STD;
+extern ::MPI_Comm MPI_COMM_NULL_STD;
+
+extern ::MPI_Status MPI_STATUS_IGNORE_STD;
+extern ::MPI_Request MPI_REQUEST_NULL_STD;
+extern ::MPI_Info MPI_INFO_NULL_STD;
+
+ep_lib::MPI_Datatype MPI_INT = MPI_INT_STD;
+ep_lib::MPI_Datatype MPI_FLOAT = MPI_FLOAT_STD;
+ep_lib::MPI_Datatype MPI_DOUBLE = MPI_DOUBLE_STD;
+ep_lib::MPI_Datatype MPI_CHAR = MPI_CHAR_STD;
+ep_lib::MPI_Datatype MPI_LONG = MPI_LONG_STD;
+ep_lib::MPI_Datatype MPI_UNSIGNED_LONG = MPI_UNSIGNED_LONG_STD;
+ep_lib::MPI_Datatype MPI_UNSIGNED_CHAR = MPI_UNSIGNED_CHAR_STD;
+
+ep_lib::MPI_Op MPI_SUM = MPI_SUM_STD;
+ep_lib::MPI_Op MPI_MAX = MPI_MAX_STD;
+ep_lib::MPI_Op MPI_MIN = MPI_MIN_STD;
+
+ep_lib::MPI_Comm MPI_COMM_WORLD(MPI_COMM_WORLD_STD);
+ep_lib::MPI_Comm MPI_COMM_NULL(MPI_COMM_NULL_STD);
+
+ep_lib::MPI_Request MPI_REQUEST_NULL(MPI_REQUEST_NULL_STD);
+ep_lib::MPI_Info MPI_INFO_NULL(MPI_INFO_NULL_STD);
+
+
+
+
Index: /XIOS/dev/branch_yushan_merged/extern/src_ep_dev/ep_declaration.hpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/extern/src_ep_dev/ep_declaration.hpp	(revision 1134)
+++ /XIOS/dev/branch_yushan_merged/extern/src_ep_dev/ep_declaration.hpp	(revision 1134)
@@ -0,0 +1,64 @@
+#ifndef EP_DECLARATION_HPP_INCLUDED
+#define EP_DECLARATION_HPP_INCLUDED
+
+extern ::MPI_Datatype MPI_INT_STD;
+extern ::MPI_Datatype MPI_FLOAT_STD;
+extern ::MPI_Datatype MPI_DOUBLE_STD;
+extern ::MPI_Datatype MPI_LONG_STD;
+extern ::MPI_Datatype MPI_CHAR_STD;
+extern ::MPI_Datatype MPI_UNSIGNED_LONG_STD;
+extern ::MPI_Datatype MPI_UNSIGNED_CHAR_STD;
+
+extern ::MPI_Op MPI_SUM_STD;
+extern ::MPI_Op MPI_MAX_STD;
+extern ::MPI_Op MPI_MIN_STD;
+
+extern ::MPI_Comm MPI_COMM_WORLD_STD;
+extern ::MPI_Comm MPI_COMM_NULL_STD;
+
+extern ::MPI_Status MPI_STATUS_IGNORE_STD;
+extern ::MPI_Request MPI_REQUEST_NULL_STD;
+extern ::MPI_Info MPI_INFO_NULL_STD;
+
+#undef MPI_INT
+#undef MPI_FLOAT
+#undef MPI_DOUBLE
+#undef MPI_CHAR
+#undef MPI_LONG
+#undef MPI_UNSIGNED_LONG
+#undef MPI_UNSIGNED_CHAR
+
+#undef MPI_SUM
+#undef MPI_MAX
+#undef MPI_MIN
+
+#undef MPI_COMM_WORLD
+#undef MPI_COMM_NULL
+
+#undef MPI_REQUEST_NULL
+
+
+
+#undef MPI_STATUS_IGNORE
+
+extern ep_lib::MPI_Datatype MPI_INT;
+extern ep_lib::MPI_Datatype MPI_FLOAT;
+extern ep_lib::MPI_Datatype MPI_DOUBLE;
+extern ep_lib::MPI_Datatype MPI_CHAR;
+extern ep_lib::MPI_Datatype MPI_LONG;
+extern ep_lib::MPI_Datatype MPI_UNSIGNED_LONG;
+extern ep_lib::MPI_Datatype MPI_UNSIGNED_CHAR;
+
+extern ep_lib::MPI_Op MPI_SUM;
+extern ep_lib::MPI_Op MPI_MAX;
+extern ep_lib::MPI_Op MPI_MIN;
+
+extern ep_lib::MPI_Comm MPI_COMM_WORLD;
+extern ep_lib::MPI_Comm MPI_COMM_NULL;
+
+extern ep_lib::MPI_Status MPI_STATUS_IGNORE;
+extern ep_lib::MPI_Request MPI_REQUEST_NULL;
+//extern ep_lib::MPI_Info MPI_INFO_NULL;
+
+#endif // EP_DECLARATION_HPP_INCLUDED
+
Index: /XIOS/dev/branch_yushan_merged/extern/src_ep_dev/ep_dup.cpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/extern/src_ep_dev/ep_dup.cpp	(revision 1134)
+++ /XIOS/dev/branch_yushan_merged/extern/src_ep_dev/ep_dup.cpp	(revision 1134)
@@ -0,0 +1,124 @@
+#include "ep_lib.hpp"
+#include <mpi.h>
+#include "ep_declaration.hpp"
+
+namespace ep_lib
+{
+
+  int MPI_Comm_dup(MPI_Comm comm, MPI_Comm *newcomm)
+  {
+    if(!comm.is_ep)
+    {
+      Debug("Comm_dup MPI\n");
+      newcomm = new MPI_Comm;
+      newcomm->is_ep = comm.is_ep;
+
+      ::MPI_Comm input = static_cast< ::MPI_Comm>(comm.mpi_comm);
+      ::MPI_Comm output;
+
+      
+      ::MPI_Comm_dup(input, &output);
+
+      newcomm->mpi_comm = output;
+
+      return 0;
+    }
+
+    if(comm.is_intercomm) return MPI_Comm_dup_intercomm(comm, newcomm);
+
+    // for intracomm
+    if(comm.mpi_comm == MPI_COMM_NULL_STD) return 0;
+
+
+    int my_rank = comm.ep_comm_ptr->size_rank_info[1].first;
+    int num_ep  = comm.ep_comm_ptr->size_rank_info[1].second;
+
+
+    if(0 == my_rank)
+    {
+      MPI_Info info;
+      MPI_Comm *out_comm;
+      ::MPI_Comm mpi_dup;
+
+      ::MPI_Comm in_comm = static_cast< ::MPI_Comm>(comm.mpi_comm);
+
+      ::MPI_Comm_dup(in_comm, &mpi_dup);
+
+      MPI_Comm_create_endpoints(mpi_dup, num_ep, info, out_comm);
+      comm.ep_comm_ptr->comm_list->mem_bridge = out_comm;
+    }
+
+    MPI_Barrier(comm);
+
+    *newcomm = (comm.ep_comm_ptr->comm_list->mem_bridge[my_rank]);
+
+    return MPI_SUCCESS;
+  }
+
+  int MPI_Comm_dup_intercomm(MPI_Comm comm, MPI_Comm *newcomm)
+  {
+    
+    if(comm.mpi_comm == MPI_COMM_NULL_STD) return 0;
+
+    int my_rank = comm.ep_comm_ptr->size_rank_info[1].first;
+    int num_ep  = comm.ep_comm_ptr->size_rank_info[1].second;
+
+
+    if(0 == my_rank)
+    {
+      MPI_Info info;
+      MPI_Comm *out_comm;
+      ::MPI_Comm mpi_dup;
+
+      ::MPI_Comm in_comm = static_cast< ::MPI_Comm>(comm.mpi_comm);
+
+      ::MPI_Comm_dup(in_comm, &mpi_dup);
+
+      MPI_Comm_create_endpoints(mpi_dup, num_ep, info, out_comm);
+
+      ::MPI_Comm mpi_inter;
+
+      ::MPI_Comm_dup(static_cast< ::MPI_Comm>(comm.ep_comm_ptr->intercomm->mpi_inter_comm), &mpi_inter);
+      
+      for(int i=0; i<num_ep; i++)
+      {
+        out_comm[i].ep_comm_ptr->comm_label = comm.ep_comm_ptr->comm_list[i].ep_comm_ptr->comm_label;
+        out_comm[i].ep_comm_ptr->intercomm = new ep_intercomm;
+
+        out_comm[i].ep_comm_ptr->intercomm->mpi_inter_comm = mpi_inter;
+        out_comm[i].is_intercomm = true;
+
+        out_comm[i].ep_comm_ptr->intercomm->intercomm_rank_map = new RANK_MAP;
+        out_comm[i].ep_comm_ptr->intercomm->local_rank_map = new RANK_MAP;
+        out_comm[i].ep_comm_ptr->intercomm->remote_rank_map = new RANK_MAP;
+
+        out_comm[i].ep_comm_ptr->intercomm->intercomm_rank_map = comm.ep_comm_ptr->comm_list[i].ep_comm_ptr->intercomm->intercomm_rank_map;
+        out_comm[i].ep_comm_ptr->intercomm->local_rank_map = comm.ep_comm_ptr->comm_list[i].ep_comm_ptr->intercomm->local_rank_map;
+        out_comm[i].ep_comm_ptr->intercomm->remote_rank_map = comm.ep_comm_ptr->comm_list[i].ep_comm_ptr->intercomm->remote_rank_map;
+
+        out_comm[i].ep_comm_ptr->intercomm->local_comm = comm.ep_comm_ptr->comm_list[i].ep_comm_ptr->intercomm->local_comm;        
+        out_comm[i].ep_comm_ptr->intercomm->intercomm_tag = comm.ep_comm_ptr->comm_list[i].ep_comm_ptr->intercomm->intercomm_tag;
+
+        for(int j =0; j<3; j++)
+        {
+          out_comm[i].ep_comm_ptr->intercomm->size_rank_info[j] = comm.ep_comm_ptr->comm_list[i].ep_comm_ptr->intercomm->size_rank_info[j];
+        }
+
+      }
+
+      comm.ep_comm_ptr->comm_list->mem_bridge = out_comm;
+    }
+
+    MPI_Barrier(comm);
+
+    *newcomm = comm.ep_comm_ptr->comm_list->mem_bridge[my_rank];
+    
+
+    return MPI_SUCCESS;
+  }
+
+
+
+}
+
+
